<template>
  <div class="">
    <h1>{{username}}'s devices</h1>

    <!-- $mqtt.connect not reactive enough it seems-->
    <v-container
      v-if="false"
      class="mt-12">
      <v-row justify="center">
        <v-col class="text-center">
          <v-progress-circular indeterminate/>
        </v-col>
      </v-row>
      <v-row justify="center">
        <v-col class="text-center">
          <span>Connecting to MQTT</span>
        </v-col>
      </v-row>
    </v-container>

    <v-container
      v-else-if="devices.length < 1"
      class="mt-12">
      <v-row justify="center">
        <v-col class="text-center">
          <v-progress-circular indeterminate/>
        </v-col>
      </v-row>
      <v-row justify="center">
        <v-col class="text-center">
          <span>Waiting for devices</span>
        </v-col>
      </v-row>
    </v-container>




    <div
      v-else
      class="devices_wrapper mt-3">
      <DevicePreview
        v-for="(device, index) in devices"
        :key="`device_${index}`"
        :device="device"
        @removed="remove_device(index)"/>
    </div>



  </div>

</template>

<script>
  import DevicePreview from '@/components/DevicePreview.vue'
  export default {
    name: 'Home',

    components: {
      DevicePreview
    },
    data(){
      return {
        devices: [],
        topic: null, // Topic in data because username gets destroyed on logoff
      }
    },
    mounted(){
      this.topic = `/${this.username}/#`
      //this.topic = `/${this.username}/devices/#`
      this.$mqtt.on('message', this.manage_message)
      this.mqtt_subscribe()
    },
    beforeDestroy() {
      this.mqtt_unsubscribe()
      this.$mqtt.removeAllListeners('message')
    },
    methods: {
      manage_message(topic, message) {

        // only deal with devices that provide their status
        if(!topic.includes('/pantilt')) return
        if(!topic.endsWith('/status')) return

        let device = {
          status_topic: topic,
          name: topic.split('/')[2],
        }

        try {
          const message_json = JSON.parse(message.toString())
          device = {
            ...device,
            ...message_json,
            json: true,
          }
        }
        catch (e) {
          device = {
            ...device,
            state: message.toString(),
            json: false,
          }
        }



        const found_device_index = this.devices.findIndex(existing_device => existing_device.name === device.name)
        if(found_device_index < 0) this.devices.push(device)
        else this.$set(this.devices,found_device_index,device)

      },
      mqtt_subscribe(){
        this.$mqtt.subscribe(this.topic)
      },
      mqtt_unsubscribe(){
        this.$mqtt.unsubscribe(this.topic)
      },
      remove_device(device_index){
        this.devices.splice(device_index,1)
      }


    },
    computed: {
      username(){
        return this.$store.state.current_user.username
      },
    }

  }
</script>

<style>

</style>
